/* 8bit u-law / 8kHz  data ñ˷Ҥ
 * shige
 * 02/16 1999 ver 0.1
 * 03/09 1999 ver 0.2
 * 05/02 2000 ver 0.3
 * auconn.c
 */
/* 02/16 1999
 * 1)	椯椯ϿʤΤĤʤѤˤ
 * 03/09 1999
 * 2)	file  full path ͿƤȤ shell  command line 
 * 	buffer θ³롣äơsearch path ꤹ褦ˤ롣
 * 	ϡ file  path Ǥʤdata format ʤɿ 
 *	command line opetion 񤱤褦ˤ롣ޤǳĥ
 *	ʤ
 * 05/02 2000
 * 3)	strtok  csrc/test/teststrt.c ˤ⤢褦ˡconstant ʸ
 *	ФƤ Bus error
 */
#ifndef __AUCONN_C__
#define __AUCONN_C__

#include "auconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,j0,k,N,inoption;
    char c,*conffname=NULL;
    Snddata snddata[Maxdatanum];

    if(argc<2){ usage(); return Exit_noarg; }
    inithome(env);
    j=1;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2pathlist(argv[j])<0){
		    usage();
		    return Exit_addstr2pathlist;
		}
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2extlist(argv[j])<0){
		    usage();
		    return Exit_addstr2extlist;
		}
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		conffname=argv[j];
		if(addfile2list(argv[j])<0){
		    usage();
		    return Exit_addfile2list;
		}
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    default:
		usage(); return Exit_unknownarg;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc){ usage(); return Exit_noarg; }
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    if(addenv2pathlist(env)<0 || addenv2extlist(env)<0 
       || addfile2list(DEFAULTConffname)<0
       || addstr2pathlist(DEFAULTPathlist)<0
       || addstr2extlist(DEFAULTExtlist)<0){
	usage(); return Exit_envdefault;
    }
    /* j  argc-1  au file ̾
     * option ˤäƤ file ̾ stdin 餦äƤΤ⤤⤷
     * ʤ
     */
    if(listonly){
	for(k=j;k<argc;k++)
	  if((tmpfile1=fopenpathlist(argv[k],tmpfile1))!=NULL)
	    fclose(tmpfile1);
	return No_err;
    }
    j0=j;
    if(argc-1-j0+1>Maxdatanum){ usage(); return Exit_toomanyarg; }
    N=argc-1-j0+1;
    if(getOneSnddata(&snddata[0],argv[j0])<0) return Exit_getOneSnddata;
    for(j=2;j<=N;j++)
      if(getSnddata(&snddata[j-1],argv[j0+j-1],&snddata[0])<0)
	return Exit_getSnddata;
    putallheader(stdout,snddata,N);
    for(j=1;j<=N;j++)
      if(putsndbodydata(&snddata[j-1],argv[j0+j-1])<0) 
	return Exit_putsndbodydata;
    return No_err;
}

/* ########## data file path or ext list subroutine ########## */
/* ʸ path list 
 */
/* mystrtok  */
int addstr2pathlist(char *str)
{
    int j=0,k;
    char *s;

    if((k=strlen(str))<=0 || k>=Maxbuff) return Err_pathstr;
    s=newfname(mystrtok(str,Pathlistdelimiter));
    do{
	/* ˤ뤫 check */
	for(k=1;k<=pathlistnum;k++)
	  if(strcmp(pathlist[k-1],s)==0) break;
	if(k>pathlistnum){
	    if(++pathlistnum>Maxpathlists) return Err_manylists;
	    j++;
	    if((pathlist[pathlistnum-1]=(char *)malloc(strlen(s)+1))==NULL)
	      return Err_malloc;
	    strcpy(pathlist[pathlistnum-1],s);
	}
    }while((s=newfname(mystrtok(NULL,Pathlistdelimiter)))!=NULL);
    return j;
}

/* ʸ ext list 
 */
int addstr2extlist(char *str)
{
    int j=0,k;
    char *s;

    if((k=strlen(str))<=0 || k>=Maxbuff) return Err_extstr;
    s=mystrtok(str,Extlistdelimiter);
    do{
	/* ˤ뤫 check */
	for(k=1;k<=extlistnum;k++)
	  if(strcmp(extlist[k-1],s)==0) break;
	if(k>extlistnum){
	    if(++extlistnum>Maxextlists) return Err_manylists;
	    j++;
	    strcpy(extlist[extlistnum-1],s);
	}
    }while((s=mystrtok(NULL,Extlistdelimiter))!=NULL);
    return j;
}

/* Ķѿɤʸ path list 
 */
int addenv2pathlist(char *env[])
{
    int len,j;

    len=strlen(DEFAULTPathEnvname);
    for(j=0;env[j]!=NULL;j++)
      if(strncmp(DEFAULTPathEnvname,env[j],len)==0)
	return addstr2pathlist(env[j]+len+1);
    return No_err;
}

/* Ķѿɤʸ ext list 
 */
int addenv2extlist(char *env[])
{
    int len,j;

    len=strlen(DEFAULTExtEnvname);
    for(j=0;env[j]!=NULL;j++)
      if(strncmp(DEFAULTExtEnvname,env[j],len)==0)
	return addstr2extlist(env[j]+len+1);
    return No_err;
}

/* configuration file ɤʸ path ext list 
 */
int addfile2list(char *fname)
{
    FILE *infile;
    char buff[Maxbuff],*s;
    int ret,total=0;

#ifdef DEBUG2
    fprintf(stderr,"[debug2] fname=%s\n",fname);
#endif /* DEBUG2 */

    if((infile=fopen(newfname(fname),"r"))==NULL){
	/* if(verbose) fprintf("File [%s] is not found.\n",fname); */
	return No_err;
    }
    while(fgets(buff,Maxbuff,infile)!=NULL){
	if(strlen(buff)==Maxbuff-1 && buff[Maxbuff-2]!='\n')
	  return Err_longconf;
	if((s=strtok(buff,Confdelimiter))!=NULL && *s!=Confcomment){
	    if(!strcmp(s,"path")){ /* "path" option */
		if((s=strtok(NULL,Confdelimiter))==NULL) 
		  return Err_conf;
		if((ret=addstr2pathlist(s))<=0) return ret;
		else total+=ret;
	    }
	    else if(!strcmp(s,"ext")){ /* "ext" option */
		if((s=strtok(NULL,Confdelimiter))==NULL) 
		  return Err_conf;
		if((ret=addstr2extlist(s))<=0) return ret;
		else total+=ret;
	    }
	}
    }
    fclose(infile);
    return total;
}

/* HOME Ķѿ set */
int inithome(char *env[])
{
    int j;

    for(j=0;env[j]!=NULL;j++)
      if(strncmp("HOME=",env[j],4+1)==0){
	  HOME=env[j]+4+1;
	  return 1;
      }
    return 0;
}

/* '~'  $HOME Ÿ
 */
char *newfname(char *fname)
{
    static char tmp[Maxpathlen];

    if(fname==NULL) return NULL;
    if(*fname != Homechar || HOME==NULL) return fname;
    if(strlen(fname)-1+strlen(HOME)+1>Maxpathlen) /* Ĺ */
      return fname;
    strcpy(tmp,HOME);
    return strcat(tmp,fname+1);
}

FILE *fopenpathlist(char *fname,FILE *target)
{
    int j,k,extlen,pathlen,fnamelen;
    char buff[Maxpathlen];
    FILE *tmpf;

    if((fnamelen=strlen(fname))<=0) return (FILE *)NULL;
    for(k=1;k<=extlistnum;k++){
	extlen=strlen(extlist[k-1]);
	if(fnamelen+extlen+1>Maxpathlen) continue;
	/* fname  path ʬĤƤޤ open Ƥߤ */
	if(iswithpath(fname)){
	    strcpy(buff,fname);
	    strcat(buff,extlist[k-1]);
	    if(target==NULL){
		if((tmpf=fopen(buff,"r"))!=NULL){
		    if(listonly) printf("%s\n",buff);
		    return tmpf;
		}
	    }
	    else if((tmpf=freopen(buff,"r",target))!=NULL){
		if(listonly) printf("%s\n",buff);
		return tmpf;
	    }
	}
	for(j=1;j<=pathlistnum;j++){
	    pathlen=strlen(pathlist[j-1]);
	    if(pathlen+1+fnamelen+1>Maxpathlen) continue;
	    if(pathlen>0){
		strcpy(buff,pathlist[j-1]);
		mystrcat(buff,Pathdelimiter);
	    }
	    else
	      buff[0]='\0';
	    strcat(buff,fname);
	    strcat(buff,extlist[k-1]);
	    if(target==NULL){
		if((tmpf=fopen(buff,"r"))!=NULL){
		    if(listonly) printf("%s\n",buff);
		    return tmpf;
		}
	    }
	    else if((tmpf=freopen(buff,"r",target))!=NULL){
		if(listonly) printf("%s\n",buff);
		return tmpf;
	    }
	}
    }
    if(verbose) fprintf(stderr,"File [%s] is not found.\n",fname);
    return (FILE *)NULL;
}

/* ########## string ########## */
/* 1) strtok()  constant ʸؤϻȤʤ
 * 2) ":a::b"  "a", "b" ֤ʤ
 */
char *mystrtok(char *str,char c)
{
    static char tmp[Maxbuff];
    static char *s0,*s1,*s2;
    
    /* if(strlen(str)>=Maxbuff) return NULL; 
     * Ƚ̤ϳǤ뤳Ȥˤ
     */
    if(str!=NULL){
	strcpy(tmp,str);
	s0=tmp;
	s2=tmp+strlen(tmp);
    } 
    else{
	if(s1>=s2) return NULL;
	s0=s1+1;
    }
    s1=s0;
    while(*s1!=c)
      if(++s1>=s2) break;
    if(s1>=s2)
      return s0;
    *s1='\0';
    return s0;
}

char *mystrcat(char *str,char c)
{
    int len=strlen(str);

    *(str+len)=c;
    *(str+len+1)='\0';
    return str;
}

int iswithpath(char *filename)
{
    if(strchr(filename,Pathdelimiter)!=NULL) return 1;
    else return 0;
}

/* ########## sndio subroutine ؤ wrapper ########## */
int getOneSnddata(Snddata *Snd,char *filename)
{
    if((tmpfile1=fopenpathlist(filename,tmpfile1))==NULL)
      return Err_fopen;
    return getSndheader(tmpfile1,Snd);
}

int getSnddata(Snddata *Snd,char *filename,Snddata *Snd0)
{
    int j;

    if((j=getOneSnddata(Snd,filename))<0) return j;
    return chSndheader(Snd0,Snd);
}

int putsndbodydata(Snddata *Snd,char *filename)
{
    int j;

    if((tmpfile1=fopenpathlist(filename,tmpfile1))==NULL)
      return Err_fopen;
    putSnddata(tmpfile1,stdout,Snd->hlen,Snd->datalen);
    fclose(tmpfile1);
    return No_err;
}

/* ########## usage ########## */
void usage(void)
{
    char *mess[]={
	"Usage: auconn [options] [aufile] ([aufile] ...)",
	" options:",
	"   -p[path]: aufile ѥ",
	"             (default= " DEFAULTPathlist ")",
	"   -e[ext] : aufile ĥ",
	"             (default= " DEFAULTExtlist ")",
	"   -f[file]: ե (default= " DEFAULTConffname ")",
	"   -l      : au file ΥꥹȤΤɽ",
	"   -q      : 顼ɽʤ",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ",
	"     ̵뤵롣ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ",
	"     ʣιԤ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ " DEFAULTPathEnvname ", " DEFAULTExtEnvname " ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ", 
	"     ץβս default: Ȥƽ񤫤Ƥ)",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}

#endif /* __AUCONN_C__ */
